"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.combineLatestInit = exports.combineLatest = void 0;
var Observable_1 = require("../Observable");
var argsArgArrayOrObject_1 = require("../util/argsArgArrayOrObject");
var identity_1 = require("../util/identity");
var createObject_1 = require("../util/createObject");
var OperatorSubscriber_1 = require("../operators/OperatorSubscriber");
var empty_1 = require("./empty");
var from_1 = require("./from");
function combineLatest(sources, resultSelector) {
    var parts = (0, argsArgArrayOrObject_1.arrayOrObject)(sources);
    if (!parts) {
        throw new TypeError('sources must be an array or object');
    }
    var observables = parts.args, keys = parts.keys;
    if (observables.length === 0) {
        return empty_1.EMPTY;
    }
    return new Observable_1.Observable(combineLatestInit(observables, keys
        ? function (values) { return (0, createObject_1.createObject)(keys, values); }
        : resultSelector
            ? function (values) { return resultSelector.apply(void 0, __spreadArray([], __read(values), false)); }
            : identity_1.identity));
}
exports.combineLatest = combineLatest;
function combineLatestInit(observables, valueTransform) {
    if (valueTransform === void 0) { valueTransform = identity_1.identity; }
    return function (subscriber) {
        var length = observables.length;
        var values = new Array(length);
        var active = length;
        var remainingFirstValues = length;
        var _loop_1 = function (i) {
            var source = (0, from_1.from)(observables[i]);
            var hasFirstValue = false;
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                values[i] = value;
                if (!hasFirstValue) {
                    hasFirstValue = true;
                    remainingFirstValues--;
                }
                if (!remainingFirstValues) {
                    subscriber.next(valueTransform(Array.from(values)));
                }
            }, function () {
                if (!--active) {
                    subscriber.complete();
                }
            }));
        };
        for (var i = 0; i < length; i++) {
            _loop_1(i);
        }
    };
}
exports.combineLatestInit = combineLatestInit;
//# sourceMappingURL=combineLatest.js.map