"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buffer = void 0;
var Observable_1 = require("../Observable");
var noop_1 = require("../util/noop");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
var from_1 = require("../observable/from");
function buffer(closingNotifier) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var currentBuffer = [];
            (0, from_1.from)(closingNotifier).subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function () {
                var b = currentBuffer;
                currentBuffer = [];
                subscriber.next(b);
            }, noop_1.noop));
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) { return currentBuffer.push(value); }, function () {
                subscriber.next(currentBuffer);
                subscriber.complete();
            }));
            return function () {
                currentBuffer = null;
            };
        });
    };
}
exports.buffer = buffer;
//# sourceMappingURL=buffer.js.map