"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.catchError = void 0;
var Observable_1 = require("../Observable");
var from_1 = require("../observable/from");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function catchError(selector) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var innerSub = null;
            var syncUnsub = false;
            var handledResult;
            innerSub = source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, undefined, undefined, function (err) {
                handledResult = (0, from_1.from)(selector(err, catchError(selector)(source)));
                if (innerSub) {
                    innerSub.unsubscribe();
                    innerSub = null;
                    handledResult.subscribe(subscriber);
                }
                else {
                    syncUnsub = true;
                }
            }));
            if (syncUnsub) {
                innerSub.unsubscribe();
                innerSub = null;
                handledResult.subscribe(subscriber);
            }
        });
    };
}
exports.catchError = catchError;
//# sourceMappingURL=catchError.js.map