"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.connect = void 0;
var Observable_1 = require("../Observable");
var Subject_1 = require("../Subject");
var from_1 = require("../observable/from");
var fromSubscribable_1 = require("../observable/fromSubscribable");
var DEFAULT_CONFIG = {
    connector: function () { return new Subject_1.Subject(); },
};
function connect(selector, config) {
    if (config === void 0) { config = DEFAULT_CONFIG; }
    var connector = config.connector;
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var subject = connector();
            (0, from_1.from)(selector((0, fromSubscribable_1.fromSubscribable)(subject))).subscribe(subscriber);
            subscriber.add(source.subscribe(subject));
        });
    };
}
exports.connect = connect;
//# sourceMappingURL=connect.js.map