"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.distinct = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
var noop_1 = require("../util/noop");
var from_1 = require("../observable/from");
function distinct(keySelector, flushes) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var distinctKeys = new Set();
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                var key = keySelector ? keySelector(value) : value;
                if (!distinctKeys.has(key)) {
                    distinctKeys.add(key);
                    subscriber.next(value);
                }
            }));
            flushes && (0, from_1.from)(flushes).subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function () { return distinctKeys.clear(); }, noop_1.noop));
        });
    };
}
exports.distinct = distinct;
//# sourceMappingURL=distinct.js.map