"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exhaustMap = void 0;
var from_1 = require("../observable/from");
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function exhaustMap(project) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var index = 0;
            var innerSub = null;
            var isComplete = false;
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (outerValue) {
                if (!innerSub) {
                    innerSub = (0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, undefined, function () {
                        innerSub = null;
                        isComplete && subscriber.complete();
                    });
                    (0, from_1.from)(project(outerValue, index++)).subscribe(innerSub);
                }
            }, function () {
                isComplete = true;
                !innerSub && subscriber.complete();
            }));
        });
    };
}
exports.exhaustMap = exhaustMap;
//# sourceMappingURL=exhaustMap.js.map