"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filter = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function filter(predicate, thisArg) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var index = 0;
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) { return predicate.call(thisArg, value, index++) && subscriber.next(value); }));
        });
    };
}
exports.filter = filter;
//# sourceMappingURL=filter.js.map