"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFind = exports.find = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function find(predicate) {
    return function (source) { return new Observable_1.Observable(function (subscriber) { return createFind(predicate, 'value', source, subscriber); }); };
}
exports.find = find;
function createFind(predicate, emit, source, subscriber) {
    var findIndex = emit === 'index';
    var index = 0;
    source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
        var i = index++;
        if (predicate(value, i, source)) {
            subscriber.next(findIndex ? i : value);
            subscriber.complete();
        }
    }, function () {
        subscriber.next(findIndex ? -1 : undefined);
        subscriber.complete();
    }));
}
exports.createFind = createFind;
//# sourceMappingURL=find.js.map