"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.materialize = void 0;
var NotificationFactories_1 = require("../NotificationFactories");
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function materialize() {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                subscriber.next((0, NotificationFactories_1.nextNotification)(value));
            }, function () {
                subscriber.next(NotificationFactories_1.COMPLETE_NOTIFICATION);
                subscriber.complete();
            }, function (error) {
                subscriber.next((0, NotificationFactories_1.errorNotification)(error));
                subscriber.complete();
            }));
        });
    };
}
exports.materialize = materialize;
//# sourceMappingURL=materialize.js.map