"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeScan = void 0;
var Observable_1 = require("../Observable");
var mergeInternals_1 = require("./mergeInternals");
function mergeScan(accumulator, seed, concurrent) {
    if (concurrent === void 0) { concurrent = Infinity; }
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var state = seed;
            return (0, mergeInternals_1.mergeInternals)(source, subscriber, function (value, index) { return accumulator(state, value, index); }, concurrent, function (value) {
                state = value;
            }, false, undefined, function () { return (state = null); });
        });
    };
}
exports.mergeScan = mergeScan;
//# sourceMappingURL=mergeScan.js.map