"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pairwise = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function pairwise() {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var prev;
            var hasPrev = false;
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                var p = prev;
                prev = value;
                hasPrev && subscriber.next([p, value]);
                hasPrev = true;
            }));
        });
    };
}
exports.pairwise = pairwise;
//# sourceMappingURL=pairwise.js.map