"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sample = void 0;
var from_1 = require("../observable/from");
var Observable_1 = require("../Observable");
var noop_1 = require("../util/noop");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function sample(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var hasValue = false;
            var lastValue = null;
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                hasValue = true;
                lastValue = value;
            }));
            (0, from_1.from)(notifier).subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function () {
                if (hasValue) {
                    hasValue = false;
                    var value = lastValue;
                    lastValue = null;
                    subscriber.next(value);
                }
            }, noop_1.noop));
        });
    };
}
exports.sample = sample;
//# sourceMappingURL=sample.js.map