"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipUntil = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
var from_1 = require("../observable/from");
var noop_1 = require("../util/noop");
function skipUntil(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var taking = false;
            var skipSubscriber = (0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function () {
                skipSubscriber === null || skipSubscriber === void 0 ? void 0 : skipSubscriber.unsubscribe();
                taking = true;
            }, noop_1.noop);
            (0, from_1.from)(notifier).subscribe(skipSubscriber);
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) { return taking && subscriber.next(value); }));
        });
    };
}
exports.skipUntil = skipUntil;
//# sourceMappingURL=skipUntil.js.map