"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipWhile = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function skipWhile(predicate) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var taking = false;
            var index = 0;
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) { return (taking || (taking = !predicate(value, index++))) && subscriber.next(value); }));
        });
    };
}
exports.skipWhile = skipWhile;
//# sourceMappingURL=skipWhile.js.map