"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.switchScan = void 0;
var switchMap_1 = require("./switchMap");
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function switchScan(accumulator, seed) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var state = seed;
            (0, switchMap_1.switchMap)(function (value, index) { return accumulator(state, value, index); })(source).subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (innerValue) {
                state = innerValue;
                subscriber.next(innerValue);
            }));
            return function () {
                state = null;
            };
        });
    };
}
exports.switchScan = switchScan;
//# sourceMappingURL=switchScan.js.map