"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.take = void 0;
var empty_1 = require("../observable/empty");
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function take(count) {
    return count <= 0
        ?
            function () { return empty_1.EMPTY; }
        : function (source) {
            return new Observable_1.Observable(function (subscriber) {
                var seen = 0;
                var operatorSubscriber = (0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                    if (++seen < count) {
                        subscriber.next(value);
                    }
                    else {
                        operatorSubscriber.unsubscribe();
                        subscriber.next(value);
                        subscriber.complete();
                    }
                });
                source.subscribe(operatorSubscriber);
            });
        };
}
exports.take = take;
//# sourceMappingURL=take.js.map