"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeLast = void 0;
var empty_1 = require("../observable/empty");
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function takeLast(count) {
    return count <= 0
        ? function () { return empty_1.EMPTY; }
        : function (source) {
            return new Observable_1.Observable(function (subscriber) {
                var ring = new Array(count);
                var counter = 0;
                source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                    ring[counter++ % count] = value;
                }, function () {
                    var start = count <= counter ? counter : 0;
                    var total = Math.min(count, counter);
                    for (var n = 0; n < total; n++) {
                        subscriber.next(ring[(start + n) % count]);
                    }
                    subscriber.complete();
                }, undefined, function () {
                    ring = null;
                }));
            });
        };
}
exports.takeLast = takeLast;
//# sourceMappingURL=takeLast.js.map