"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeUntil = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
var from_1 = require("../observable/from");
var noop_1 = require("../util/noop");
function takeUntil(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            (0, from_1.from)(notifier).subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function () { return subscriber.complete(); }, noop_1.noop));
            !subscriber.closed && source.subscribe(subscriber);
        });
    };
}
exports.takeUntil = takeUntil;
//# sourceMappingURL=takeUntil.js.map