"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeWhile = void 0;
var Observable_1 = require("../Observable");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
function takeWhile(predicate, inclusive) {
    if (inclusive === void 0) { inclusive = false; }
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var index = 0;
            var operatorSubscriber = (0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) {
                if (predicate(value, index++)) {
                    subscriber.next(value);
                }
                else {
                    operatorSubscriber.unsubscribe();
                    if (inclusive) {
                        subscriber.next(value);
                    }
                    subscriber.complete();
                }
            });
            source.subscribe(operatorSubscriber);
        });
    };
}
exports.takeWhile = takeWhile;
//# sourceMappingURL=takeWhile.js.map