"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.window = void 0;
var Observable_1 = require("../Observable");
var Subject_1 = require("../Subject");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
var noop_1 = require("../util/noop");
var from_1 = require("../observable/from");
function window(windowBoundaries) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var windowSubject = new Subject_1.Subject();
            subscriber.next(windowSubject.asObservable());
            var errorHandler = function (err) {
                windowSubject.error(err);
                subscriber.error(err);
            };
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) { return windowSubject === null || windowSubject === void 0 ? void 0 : windowSubject.next(value); }, function () {
                windowSubject.complete();
                subscriber.complete();
            }, errorHandler));
            (0, from_1.from)(windowBoundaries).subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function () {
                windowSubject.complete();
                subscriber.next((windowSubject = new Subject_1.Subject()));
            }, noop_1.noop, errorHandler));
            return function () {
                windowSubject === null || windowSubject === void 0 ? void 0 : windowSubject.unsubscribe();
                windowSubject = null;
            };
        });
    };
}
exports.window = window;
//# sourceMappingURL=window.js.map