"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.windowWhen = void 0;
var Observable_1 = require("../Observable");
var Subject_1 = require("../Subject");
var OperatorSubscriber_1 = require("./OperatorSubscriber");
var from_1 = require("../observable/from");
var noop_1 = require("../util/noop");
function windowWhen(closingSelector) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var window;
            var closingSubscriber;
            var handleError = function (err) {
                window.error(err);
                subscriber.error(err);
            };
            var openWindow = function () {
                closingSubscriber === null || closingSubscriber === void 0 ? void 0 : closingSubscriber.unsubscribe();
                window === null || window === void 0 ? void 0 : window.complete();
                window = new Subject_1.Subject();
                subscriber.next(window.asObservable());
                var closingNotifier;
                try {
                    closingNotifier = (0, from_1.from)(closingSelector());
                }
                catch (err) {
                    handleError(err);
                    return;
                }
                closingNotifier.subscribe((closingSubscriber = (0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, openWindow, noop_1.noop, handleError)));
            };
            openWindow();
            source.subscribe((0, OperatorSubscriber_1.createOperatorSubscriber)(subscriber, function (value) { return window.next(value); }, function () {
                window.complete();
                subscriber.complete();
            }, handleError, function () {
                closingSubscriber === null || closingSubscriber === void 0 ? void 0 : closingSubscriber.unsubscribe();
                window = null;
            }));
        });
    };
}
exports.windowWhen = windowWhen;
//# sourceMappingURL=windowWhen.js.map