import { mergeAll } from '../operators/mergeAll';
import { EMPTY } from './empty';
import { popNumber, popScheduler } from '../util/args';
import { scheduled } from '../scheduled/scheduled';
import { from } from './from';
export function merge(...args) {
    const scheduler = popScheduler(args);
    const concurrent = popNumber(args, Infinity);
    const sources = args;
    return !sources.length
        ?
            EMPTY
        : sources.length === 1
            ?
                from(sources[0])
            :
                mergeAll(concurrent)(scheduler ? scheduled(sources, scheduler) : from(sources));
}
//# sourceMappingURL=merge.js.map