import { Observable } from '../Observable';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function find(predicate) {
    return (source) => new Observable((subscriber) => createFind(predicate, 'value', source, subscriber));
}
export function createFind(predicate, emit, source, subscriber) {
    const findIndex = emit === 'index';
    let index = 0;
    source.subscribe(createOperatorSubscriber(subscriber, (value) => {
        const i = index++;
        if (predicate(value, i, source)) {
            subscriber.next(findIndex ? i : value);
            subscriber.complete();
        }
    }, () => {
        subscriber.next(findIndex ? -1 : undefined);
        subscriber.complete();
    }));
}
//# sourceMappingURL=find.js.map