import { Observable } from '../Observable';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function pairwise() {
    return (source) => new Observable((subscriber) => {
        let prev;
        let hasPrev = false;
        source.subscribe(createOperatorSubscriber(subscriber, (value) => {
            const p = prev;
            prev = value;
            hasPrev && subscriber.next([p, value]);
            hasPrev = true;
        }));
    });
}
//# sourceMappingURL=pairwise.js.map