import { from } from '../observable/from';
import { Observable } from '../Observable';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function switchMap(project) {
    return (source) => new Observable((subscriber) => {
        let innerSubscriber = null;
        let index = 0;
        let isComplete = false;
        const checkComplete = () => isComplete && !innerSubscriber && subscriber.complete();
        source.subscribe(createOperatorSubscriber(subscriber, (value) => {
            innerSubscriber === null || innerSubscriber === void 0 ? void 0 : innerSubscriber.unsubscribe();
            const outerIndex = index++;
            from(project(value, outerIndex)).subscribe((innerSubscriber = createOperatorSubscriber(subscriber, undefined, () => {
                innerSubscriber = null;
                checkComplete();
            })));
        }, () => {
            isComplete = true;
            checkComplete();
        }));
    });
}
//# sourceMappingURL=switchMap.js.map