import { switchMap } from './switchMap';
import { Observable } from '../Observable';
import { createOperatorSubscriber } from './OperatorSubscriber';
export function switchScan(accumulator, seed) {
    return (source) => new Observable((subscriber) => {
        let state = seed;
        switchMap((value, index) => accumulator(state, value, index))(source).subscribe(createOperatorSubscriber(subscriber, (innerValue) => {
            state = innerValue;
            subscriber.next(innerValue);
        }));
        return () => {
            state = null;
        };
    });
}
//# sourceMappingURL=switchScan.js.map